<?php
session_start();
    # Page des autorisations d'import 
    # (C) MAP/SG/SM/SDSI/CERI/DIG 2006
    require('core/config.php');
    require('core/authentification_api.php');
    require('core/html_api.php');
    require('core/date_api.php');
    require('core/database_api.php');

   
    //vérification de la session
    $resultat=test_session("user"); 
    if ($resultat === false ){
        $href="login.php?login=";
        echo "<meta http-equiv=\"refresh\" content=\"0; URL=$href\">\n";
    }else{

    # Connexion à Page d'accueil
    html_begin( "Export", "" );
    html_bandeau();
    
    if (test_session("admin")<>1){
       warning_autorisation();
       html_end();
      }
    else{
      print_session();
       
    ?>
   
    <h1>Autorisations d'exportation de données</h1>

    <p>Cette page liste les couches que vous avez autorisés d'exporter vers d'autres serveurs GéoBASE.</p>
    <table  >
    <tr></tr>
    <tr></tr>
    <tr class="txtcontenu">
       <td  colspan="7" >
            Liste des exports
            [&nbsp;<a href="add_export_page.php?action=add">Ajouter</a>&nbsp;]
       </td>
    </tr>
    </table>
    <table width="100%" frame="box" rules=rows cellpadding="5">
    <tr class="tabletexte"> 
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>Nom de la couche</td>
        <td>Nom du serveur GéoBASE</td>
    </tr>
    <?php
    $result=db_query('SELECT * FROM '.$g_schema_gb.'.gb_export order by nom_couche');
    $num_rows=db_num_rows($result);
    $i=0;
    if ($num_rows>0){
        while ($row=db_fetch_array($result)){
            $i++;
            if ($i%2 == 0){
                ?>  
                <tr class="evenRow">
                <?php
            }else{
                ?>
                <tr class="oddRow">
                <?php
            }
            ?>
            <td width=20>
            <center>
            <a href="add_export_page.php?action=edit&amp;id_export=<?php echo $row['id_export'] ?>">
                <img border="0" src="images/update.png" title="Editer l'autorisation d'export" />
            </a>
            </center>
            </td>     
            <td width=20>
            <center>
            <a href="script_export.php?id_export=<?php echo $row['id_export'] ?>&amp;action=delete_export">
                <img border="0" src="images/delete.png" title="Supprimer la demande d'import" />
            </a>
            </center>
            </td>     
                <td><?php echo $row['nom_couche'] ?></td>
                <td><?php echo $row['nom_serveur'] ?></td>
            </tr>
            <?php
        }
    }
    ?>
    </table>
    <br />
    <p align="right"><a href="import_export.php">[ Retour ]</a></p>  
    <?php     
   // deconnexion 
    db_close();
    html_end();
    }
}
 ?>
