<?php
##
# Cette page permet au script schell lancé par cron la nuit de vérifier que
# le serveur est autorisé à venir récupérer une couche MapInfo dans la GéoBASE
#
#
#
##
require('core/config.php');
require('core/authentification_api.php');
require('core/html_api.php');
require('core/date_api.php');
require('core/database_api.php');
require('core/cougra_api.php');

$nom_couche=$_GET['c'];
$serveur=$_GET['s'];
$date=$_GET['date'];
$md5tab_distant=$_GET['md5tab'];
$md5map_distant=$_GET['md5map'];
$md5dat_distant=$_GET['md5dat'];
$acreer=$_GET['acreer'];

//on teste si la couche existe sur le serveur
$retour_cougra=lire_cougra($nom_couche);
if ($retour_cougra === false) {
	echo 'nolayer';
	exit;
}
//Est-on en consultation ou en ref ?
if ($retour_cougra['base']=='P' || $retour_cougra['base']=='C') {
	$base='CONSULTATION';
}else{
	$base='REF_EXT';
}
$cheminFichier=$param['chemin_geobase'].'/'.$base.'/'.$retour_cougra['chemin'].'/'.$retour_cougra['nom_local'];
if (! file_exists( $cheminFichier . '.TAB') ) {
	echo 'nolayer';
	exit;
}
//requête à la base de données pour connaitre l'autorisation du serveur appelant
$result=db_query('SELECT * FROM '.$g_schema_gb.'.gb_export WHERE nom_couche=\''.$nom_couche.'\' and (serveur=\''.$serveur.'\' or serveur=\'*\');');
if (db_num_rows($result) < 1 ) {
	//Aucun résultat, le serveur n'est donc pas autorisé => on renvoie 'noperm'
	echo 'noperm';
} else {
	//autorisation => oki
	//On teste si la couche à changer par rapport à la dernière mise à jour grâce au md5
	//on récupère md5sum chemin_couche => md5 nom_couche
	//on expldoe le résultat pour ne récupérer que la somme des chiffrements
	if ($acreer != 'oui') {
		$md5tab_local=exec ( 'md5sum ' . $cheminFichier . '.TAB');
		$md5tab_local=explode(' ', $md5tab_local);
		$md5map_local=exec ( 'md5sum ' . $cheminFichier . '.MAP');
		$md5map_local=explode(' ', $md5map_local);
		$md5dat_local=exec ( 'md5sum ' . $cheminFichier . '.DAT');
		$md5dat_local=explode(' ', $md5dat_local);
		$changer=false;
		//on compare les md5sum locaux avec les distants
		if ($md5tab_local[0]<>$md5tab_distant){
			$changer=true;
		}
		if ($md5map_local[0]<>$md5map_distant){
			$changer=true;
		}
		if ($md5dat_local[0]<>$md5dat_distant){
			$changer=true;
		}
		if ($changer==false){
			//si rien n'a changé on renvoie 'ajour'
			echo 'ajour';
			exit;
		}
	}
	
	$nom_unique=uniqid(mt_rand()); //Pour éviter que les téléchargement et création d'archives se téléscopent
	//on créé un fichier dans lequel on indique le chemin dans la géobase
	$Fnm = "/tmp/".$nom_unique.".txt";
	$inF = fopen($Fnm,"w");
	fwrite($inF, $param['chemin_geobase'].'/'.$base.'/'.$retour_cougra['chemin'] );
	fclose($inF);
	
	//on créé une archive pour que le serveur distant puisse télécharger les données
	//Création de l'archive NOM_COUCHE.ZIP
	
	$exec='zip -j '.$param['chemin_tmp'].'/'.$nom_unique.'.ZIP ';
	if (file_exists($cheminFichier.'.TAB')){
		$exec.=$cheminFichier.'.TAB ';
	}
	if (file_exists($cheminFichier.'.ID')){
		$exec.=$cheminFichier.'.ID ';
	}
	if (file_exists($cheminFichier.'.MAP')){
		$exec.=$cheminFichier.'.MAP ';
	}
	if (file_exists($cheminFichier.'.DAT')){
		$exec.=$cheminFichier.'.DAT ';
	}
	if (file_exists($cheminFichier.'.IND')){
		$exec.=$cheminFichier.'.IND ';
	}
	if (file_exists("/tmp/".$nom_unique.".txt")){
		$exec.="/tmp/".$nom_unique.".txt";
	}
	exec($exec);
	
/*
	//$zip = new ZipArchive();
	$filename_zip = $param['chemin_tmp'].'/'.$nom_unique.'.ZIP';
	if ($zip->open($filename_zip)!==TRUE) {
		exit("cannot open <$filename>\n");
	}
	if (file_exists($cheminFichier.'.TAB')){
		$zip->addFile($cheminFichier.'.TAB');
	}
	if (file_exists($cheminFichier.'.ID')){
		$zip->addFile($cheminFichier.'.ID');
	}
	if (file_exists($cheminFichier.'.MAP')){
		$zip->addFile($cheminFichier.'.MAP');
	}
	if (file_exists($cheminFichier.'.DAT')){
		$zip->addFile($cheminFichier.'.DAT');
	}
	if (file_exists($cheminFichier.'.IND')){
		$zip->addFile($cheminFichier.'.IND');
	}
	$zip->close();
*/
	echo $nom_unique.'.ZIP';
}
?>
