<?php 
session_start();
require('core/config.php');
require_once('core/database_api.php');
include_once( "core/html_api.php" );
require_once('core/authentification_api.php');
//verification de la session
$resultat=test_session("user");
html_begin( "Documentation", "" );
html_bandeau();

if (test_session("admin")<>1){
warning_autorisation();
html_end();
}else{
?>
<h1><a name="debut">Documentation G&eacute;oMAP - Admin</a></h1>

<hr>
<p>Ce site a pour but de g&eacute;rer les fichiers de
configuration
n&eacute;cessaires &agrave; la gestion de
certaines
applications du projet G&eacute;oMAP. Il se compose de plusieurs
modules :</p>

<ul>
  <li>La configuration de l'application d'&eacute;change
entre G&eacute;oBASEs par la gestion des fichiers Import -Exports.</li>
</ul>

<p>Seul&nbsp; l'administrateur du projet G&eacute;oMAP peut
acc&eacute;der au site. <br><b>L'administrateur doit demander les droits d'acc&egrave;s aupr&egrave;s du DIG &agrave;l'adresse m&eacute;l suivante : assistdig.sg@agriculture.gouv.fr</b></p>

<hr>
<h2>Configuration minimale</h2>


<p>Navigateurs support&eacute;s :</p>

<ul>

  <li>Mozilla Firefox</li>

  <li>Mozilla 1.7 et +</li>

  <li>SeaMonkey 1.0 et +</li>

  <li>Internet Explorer version 6 et +</li>

</ul>

<p align="right"><a href="#debut"><img alt="" src="help/images/up_layer.png"></a></p>
<hr>
<h2>Acc&egrave;s au site</h2>

<div id="documentation">
<p>L'acc&egrave;s au site r&eacute;serv&eacute;
&agrave;
l'administrateur se fait par la saisie du login AGRICOLL (nom
d'utilisateur et mot de passe Agricoll). Les agents de l'Équipement peuvent également se connecter via Cerbère en cliquant sur le bouton idoine.
</p>

<img alt="Authentification" title="Authentification" src="help/images/accueil_authentification.png"



<p>Si l'utilisateur est administrateur, il a accès aux différents modules de l'application.</p>

<img alt="Page d'Accueil" title="Page d'accueil" src="help/images/accueil.png">

<ul>

</ul>
<p align="right"><a href="#debut"><img alt="" src="help/images/up_layer.png"></a></p>
<hr style="width: 100%; margin-top: 28px; height: 0px;"><br>


<h2>Menu principal</h2>
<p>Le menu principal pr&eacute;sente les diff&eacute;rents modules
de gestion&nbsp;du projet G&eacute;oMAP.</p>
<img alt="Menu principal" title="Menu principal" src="help/images/menuprincipal.png">
<p>Modules disponibles :</p>
<ul>
<li>Import/Export permet de configurer les couches échangeables entre GéoBASEs.</li>
</ul>
<p>Chaque module possède sa propre page d'aide accessible en bas de chaque menu déroulant.</p>

<br>
<p align="right"><a href="#debut"><img alt="" src="help/images/up_layer.png"></a></p>
<hr style="width: 100%; height: 2px;"><br>
<?
  html_end();
  }
?>
