<?php
session_start();
require_once('core/config.php');
require_once('core/database_api.php'); 
include_once( "core/html_api.php" );
require_once( "core/date_api.php" );
require_once('core/authentification_api.php');
require_once( "core/cougra_api.php" );

//verification de la session
$resultat=test_session("user");
# Page de saisie des bases
# (C) MAP/SG/SM/SDSI/CERI/DIG 2006
html_begin("Saisie export", '');
html_bandeau();

if (test_session("admin")<>1){
    warning_autorisation();
    html_end();
}else{
    
    $action=$_GET['action'];
    if ($action=='add'){
        $form_action='script_export.php?action=insert_export';
    }else{
        $form_action='script_export.php?action=update_export';
    }
    //récupération de l'adresse IP de la machine LINDA
    $ip_serveur=$_SERVER["SERVER_ADDR"];
    if ($ip_serveur=='127.0.0.1'){
        $ip_serveur='10.207.132.104';
    }
    
    if ($action=='add'){
        #Forumlaire de Saisie d'un nouvel export
    ?>
    <form name="Export" method="POST" action="<?php echo $form_action ?>">
    
    <h1>Ajouter une autorisation d'export</h1>
    <fieldset>
    <legend>Ajouter un export</legend>
    <p>Choisissez une couche à exporter puis choisissez la GéoBASE vers laquelle vous autorisez l'exportation.</p>
    <?php 
    # On récupère la liste des couches depuis le service Web de GéoRépertoire
    $urlLocalLayers = 'http://georepertoire.national.agri/get_local_layers.php?p_site='.$ip_serveur;  
    $handle=@fopen($urlLocalLayers, 'r');
    $contents = '';
    if ($handle){
        while (!feof($handle)) {
        $contents .= fread($handle, 8192);
        }
    }
    if ($contents<>''){
        $tabCouches = explode(';', $contents);
        if ($contents<>'0'){
            ?>
            <p><label>Choisir une couche de votre GéoBASE :</label>
            <select id="lst_layer_local" name="lst_layer_local">
            <?php
        
            $tabCouches = explode(';', $contents);
            foreach($tabCouches as $couche){
                if ($couche<>''){
                    ?>
                    <option value="<?php echo $couche ?>"><?php echo $couche ?></option>
                    <?php
                    $couchesLocales = rechercheCoucheVersion($couche);
                    if (count($couchesLocales)>0){
                        foreach($couchesLocales as $coucheLocale){
                            if ($coucheLocale<>$couche){
                                ?>
                                <option value="<?php echo $coucheLocale ?>"><?php echo $coucheLocale ?></option>
                                <?php
                            }
                        }
                        
                    }
                }
            }
            ?>
            </select></p>
            
            <?php
            # On récupère la liste des couches depuis le service Web de GéoRépertoire
            $urlGeobase = 'http://georepertoire.national.agri/get_geobase_list.php';
            $handle=fopen($urlGeobase, 'r');
            $contents = '';
            
            while (!feof($handle)) {
              $contents .= fread($handle, 8192);
            }
            fclose($handle);
            $tabGeobases = explode(';', $contents);
            ?>
            <p><label>Choisir un serveur GéoBASE pour l'exportation :</label>
            <select multiple id="lst_serveur" name="lst_serveur[]" >
            <option value="*">Toutes les GéoBASEs</option>
            <?php
            
            foreach($tabGeobases as $geobase){
                $geobaseDetail = explode('|', $geobase);
                if ($geobaseDetail[1]<>'BDNT' and $geobaseDetail[1]<>'Aucune' and $geobaseDetail[0]<>$ip_serveur){
                    ?>
                    <option value="<?php echo $geobaseDetail[0].'|'.$geobaseDetail[1] ?>"><?php echo utf8_encode($geobaseDetail[1]) ?></option>
                    <?php
                }
            }
            ?>
            </select>
            </p>
            <input type="submit" name="bouton" value="Valider" />
        <?php
        }else{
            ?>
            <br />
            <br />
            <p>Votre serveur ne contient pas de couches locales. Veuillez décrire vos couches de données dans le GéoRépertoire.</p>
            <br />
            <?php   
        }
    }else{
        ?>
        <p>Le serveur GéoRépertoire ne répond pas. Veuillez réessayer plus tard ou contacter l'assistance du DIG : <a href="mailto:<?php echo $g_mail_assistance ?>"><?php echo $g_mail_assistance ?></a></p>
        <?php
    }
    ?>
    </fieldset>  
    </form>
    <br />
    <p align="right"><a href="export_gb.php">[Retour]</a></p>
    <?php
    }else{
        #Formulaire d'édition d'un import
        ?>
        <h1>Modifier cette autorisation d'exportation</h1>
        <form name="Export" method="POST" action="<?php echo $form_action ?>">
        <fieldset>
        <legend>Modifier un export</legend>
        <?php
        $result=db_query('SELECT * FROM '.$g_schema_gb.'.gb_export WHERE id_export='.$_GET['id_export']);
        $nom_couche=db_result($result, 0, 'nom_couche');
        ?>
        <p>Cet export concerne la couche : <?php echo $nom_couche ?></p>
        <?php
        # On récupère la liste des couches depuis le service Web de GéoRépertoire
        $urlGeobase = 'http://georepertoire.national.agri/get_geobase_list.php';
        $handle=fopen($urlGeobase, 'r');
        $contents = '';
        while (!feof($handle)) {
          $contents .= fread($handle, 8192);
        }
        fclose($handle);
        if ($contents<>''){
            $tabGeobases = explode(';', $contents);
            ?>
            <p><label>Choisir un serveur GéoBASE pour l'exportation :</label>
            <select multiple id="lst_serveur" name="lst_serveur[]" >
            <option value="*">Toutes les GéoBASEs</option>
            <?php
            
            foreach($tabGeobases as $geobase){
                $geobaseDetail = explode('|', $geobase);
                if ($geobaseDetail[1]<>'BDNT' and $geobaseDetail[1]<>'Aucune' and $geobaseDetail[0]<>$ip_serveur){
                    ?>
                    <option value="<?php echo $geobaseDetail[0].'|'.$geobaseDetail[1] ?>"><?php echo utf8_encode($geobaseDetail[1]) ?></option>
                    <?php
                }
            }
            ?>
            </select>
            </p>
            <input type="hidden" name="id_export" value="<?php echo $_GET['id_export'] ?>" />
            <input type="hidden" name="nom_couche" value="<?php echo $nom_couche ?>" />
            <input type="submit" name="bouton" value="Valider" />
            <?php
        }else{
            ?>
            <p>Le serveur GéoRépertoire ne répond pas. Veuillez réessayer plus tard ou contacter l'assistance du DIG : <a href="mailto:<?php echo $g_mail_assistance ?>"><?php echo $g_mail_assistance ?></a></p>
            <?php
        }
        ?>
        </fieldset>
        <br />
        <p align="right"><a href="export_gb.php">[Retour]</a></p>
        <?php
    }
                                                                                   
html_end();
}     
?>
