<?php
session_start();
require_once('core/config.php');
require_once('core/database_api.php'); 
include_once( "core/html_api.php" );
require_once( "core/date_api.php" );
require_once('core/authentification_api.php');

//verification de la session
$resultat=test_session("user");
# Page de saisie des bases
# (C) MAP/SG/SM/SDSI/CERI/DIG 2006
html_begin("Saisie import", 'javascript/ajax_functions.js');
html_bandeau();

if (test_session("admin")<>1){
    warning_autorisation();
    html_end();
}else{
    
    $action=$_GET['action'];
    if ($action=='add'){
        $form_action='script_import.php?action=insert_import';
    }else{
        $form_action='script_import.php?action=update_import';
    }
    
    //récupération de l'adresse IP de la machine LINDA
    $ip_serveur=$_SERVER["SERVER_ADDR"];
    if ($ip_serveur=='127.0.0.1'){
        $ip_serveur='10.202.64.2';
    }
    
    if ($action=='add'){
        #Forumlaire de Saisie d'un nouvel import
        ?>
        <h1>Ajouter une demande d'importation</h1>
        <form name="Import" method="POST" action="<?php echo $form_action ?>">
        <fieldset>
        <legend>Ajouter un import</legend>
        <?php

            # On récupère la liste des couches depuis le service Web de GéoRépertoire
            $urlGeobase = 'http://georepertoire.national.agri/get_geobase_list.php';
            $handle=fopen($urlGeobase, 'r');
            $contents = '';
            while (!feof($handle)) {
              $contents .= fread($handle, 8192);
            }
            fclose($handle);
            if ($contents<>''){
                $tabGeobases = explode(';', $contents);
                ?>
                <p><label>Choisir un serveur GéoBASE pour l'exportation :</label>
                 <select id="lst_serveur" name="lst_serveur" onchange="recup_liste_couche()">
                <option value="*">Toutes les GéoBASEs</option>
                <?php
                
                foreach($tabGeobases as $geobase){
                    $geobaseDetail = explode('|', $geobase);
                    if ($geobaseDetail[1]<>'BDNT' and $geobaseDetail[1]<>'Aucune' and $geobaseDetail[0]<>$ip_serveur){
                        ?>
                        <option value="<?php echo $geobaseDetail[0].'|'.$geobaseDetail[5] ?>"><?php echo utf8_encode($geobaseDetail[1]) ?></option>
                        <?php
                    }
                }
                ?>
                </select>
                </p>
        <?php
        }
        else{
            ?>
            <p>Le serveur GéoRépertoire ne répond pas. Veuillez réessayer plus tard ou contacter l'assistance du DIG : <a href="mailto:<?php echo $g_mail_assistance ?>"><?php echo $g_mail_assistance ?></a></p>
            <?php
        }
    ?>
    <div id="liste_couches">
     <br />
     <br />
     <br />
     <br />
    <br />
    <br />
    </div>
    </fieldset>  
    </form>
    
    <br />
    <p align="right"><a href="import_gb.php">[Retour]</a></p>
    <?php
    }else{
        #Formulaire d'édition d'un import
        ?>
        <h1>Modifier la demande d'importation</h1>
        <form name="Import" method="POST" action="<?php echo $form_action ?>">
        <fieldset>
        <legend>Modifier un import</legend>
        <?php
        $result=db_query('SELECT * FROM '.$g_schema_gb.'.gb_import WHERE nom_couche=\''.$_GET['nom_couche'].'\';');
        if (db_result($result,0,'archiver')=='t'){
            $chkbox=' checked';
        }else{
            $chkbox='';
        }
        ?>
        <p><label>Archiver cette couche ? </label><input type="checkbox" <?php echo $chkbox ?> name="chk_archiver" /></p>
        <input type="hidden" name="couche" value="<?php echo $_GET['nom_couche'] ?>" />
        <input type="submit" name="bouton" value="Valider" />
        </fieldset>
        </form>
        <br />
        <p align="right"><a href="import_gb.php">[Retour]</a></p>
        <?php
    }                                                                         
html_end();
}     
?>
