<?php
$serveur=$_GET['serveur'];
$nom=explode('|', $serveur);
$serveur=$nom[0];
$nom_serveur=$nom[1];
require('core/config.php');
require('core/database_api.php');

# On récupère la liste des couches depuis le service Web de GéoRépertoire
$urlLocalLayers = 'http://georepertoire.national.agri/get_local_layers.php?p_site='.$serveur;
$handle=@fopen($urlLocalLayers, 'r');
$contents = '';
if ($handle){
    while (!feof($handle)) {
    $contents .= fread($handle, 8192);
    }
}
if ($contents<>''){
        $tabCouches = explode(';', $contents);
        if ($contents<>'0'){
            ?>
            <p><label>Choisir une couche :</label>
            <select id="lst_layer_local" name="lst_layer_local">
            <?php
            foreach($tabCouches as $couche){
                if ($couche<>''){
                    ?>
                    <option value="<?php echo $couche ?>"><?php echo $couche ?></option>
                    <?php
                    # Pour chaque couche, on regarde si cette dernière ne possède pas de version. Cette donnée n'est pas contenu dans la base de données de GéoRépertoire, mais on interroge le géorépertoire qui détient les COUGRA.XML des GéoBASEs
                    $url = 'http://georepertoire.national.agri/get_version_couche.php?p_site='.$serveur.'&p_couche='.$couche;
                    $handle=fopen($url, 'r');
                    $contents = '';
                    while (!feof($handle)) {
                      $contents .= fread($handle, 8192);
                    }
                    fclose($handle);
                    if ($contents<>''){
                        $tabVersion = explode(';', $contents);
                        foreach ($tabVersion as $version){
                            if ($version<>''){
                                ?>
                                <option value="<?php echo $version ?>"><?php echo $version ?></option>
                                <?php
                            }
                        }
                    }
                }
            }
            ?>
            </select></p>
            <p><label>Archiver la données ? </label><input type="checkbox" name="chk_archiver" /></p>
            <input type="hidden" name="serveur" value="<?php echo $_POST['serveur'] ?>" />
            <input type="submit" name="bouton" value="Valider" />
        <?php
    }else{
        ?>
        <br />
        <br />
        <p>Ce serveur ne contient pas de couches locales. Veuillez choisir un autre serveur.</p>
        <br />
        <?php   
    }
}else{
    ?>
    <p>Le serveur GéoRépertoire ne répond pas. Veuillez réessayer plus tard ou contacter l'assistance du DIG : <a href="mailto:<?php echo $g_mail_assistance ?>"><?php echo $g_mail_assistance ?></a></p>
    <?php
}
?>
