<?php
###########################################################################################
# Auteur : Suzanne LORIOL
# Date : 26/04/06
#
# Description : focntions de'accès à COUGRA.XML

require_once('config.php');
global $param;

function startswith($hay, $needle) {
    return $needle === $hay or strpos($hay, $needle) === 0;
}

# LECTURE COUGRA
function lire_cougra($nom_couche){
    global $param;
//$file="/geobase/ref/COUGRA.XML";

  $file=$param['chemin_cougra']."COUGRA.XML";
  $fp =file_exists($file);

    if (! $fp)
        return false;

    $fp = fopen($file, 'r');
    
    $xml_parser = xml_parser_create( '' );

    $data = fread($fp, filesize($file));
    fclose($fp);
    xml_parse_into_struct($xml_parser, $data, $vals, $index);
    xml_parser_free($xml_parser);

    $params = array();
    
    foreach ($vals as $xml_elem) {
        if ($xml_elem['tag'] == 'ENTRY') {
        if (array_key_exists('attributes',$xml_elem)) {
        $enr = $xml_elem['attributes']; 
        $tab['nom_local'] = $enr['COUGRA_RFA'];
        //echo $tab['nom_local'];
        
        if ($nom_couche==$tab['nom_local']){
            
            $enr = $xml_elem['attributes'];
            $tab['type'] =$enr['TYPE_CDA'];
            $tab['chemin'] = str_replace( '\\', '/', $enr['CHEMIN_LB']);
            $tab['base']=$enr['CHDESC_LB'];
            $params = $tab;
            }
        }
        }
    }
    return $params;
}

# Permet de retrouver des versions de couches à partir du nom d'une couche
function rechercheCoucheVersion($nomCouche){
    global $param;
    $file=$param['chemin_cougra']."COUGRA.XML";
    $fp =file_exists($file);
    if (! $fp)
        return false;
    $fp = fopen($file, 'r');
    $xml_parser = xml_parser_create( '' );
    $data = fread($fp, filesize($file));
    fclose($fp);
    xml_parse_into_struct($xml_parser, $data, $vals, $index);
    xml_parser_free($xml_parser);
    $coucheVersion = array();
    foreach ($vals as $xml_elem) {
        if ($xml_elem['tag'] == 'ENTRY') {
            if (array_key_exists('attributes',$xml_elem)) {
                $enr = $xml_elem['attributes'];
                if (startswith($enr['COUGRA_RFA'], $nomCouche)){
                    $coucheVersion[] = $enr['COUGRA_RFA'];
                }
            }
        }
    }
    return $coucheVersion;
}

function get_list_couche_from_cougra(){
    global $param;
//$file="/geobase/ref/COUGRA.XML";

  $file=$param['chemin_cougra']."COUGRA.XML";

  $fp =file_exists($file);

    if (! $fp)
        return false;

    $fp = fopen($file, 'r');
    
    $xml_parser = xml_parser_create( '' );

    $data = fread($fp, filesize($file));
    fclose($fp);
    xml_parse_into_struct($xml_parser, $data, $vals, $index);
    xml_parser_free($xml_parser);
    $params = array();
    $i=0;
    foreach ($vals as $xml_elem) {
        if ($xml_elem['tag'] == 'ENTRY') {
            if (array_key_exists('attributes',$xml_elem)) {
        $enr = $xml_elem['attributes']; 
        $params[$i]['nom'] = $enr['COUGRA_RFA'];
                $params[$i]['base'] = $enr['CHDESC_LB'];
                $params[$i]['chemin'] = str_replace( '\\', '/', $enr['CHEMIN_LB']);

                $i++;
        }   
        }
    }
    return $params;

}
?>
