<? 
###################################################################################
# Fonction : creer_liste
# Auteur: Mathieu Rajerison, Sylvain Perrinel
# Date: 12/06/2005
# Description : Créer une liste de choix à partir d'une table d'une base de données
# * $nom_liste : nom de la liste à créer
# * $entete : entête de la liste (1er élément)
# * $nom_table : nom de la table dans la base de données à partir de laquelle on veut 
# construire la liste
# * $id_champ : identifiant du champ dans la bdd pour les valeurs des options de la liste
# * $nom_champ : nom du champ dans la bdd pour l'affichage des options de la liste
# * $action_javascript : action javascript sur le onchange de la liste
# * $selected : valeur du champ préselectionné (valeur d'un id_champ)
# * $size : taille de la liste (par défaut un seul élément affiché)

function creer_liste($nom_liste,$entete, $nom_table,$id_champ,$nom_champ, $action_javascript, $selected, $size, $where="")
 
{
require ('config.php');
//longueur max des libelles
$max=21; 

$res=db_connect( $g_pg_hostname, $g_pg_db_user, $g_pg_db_pwd, $g_pg_port, $g_pg_db_name );

echo "<select name='$nom_liste' id='$nom_liste' size='$size' Onchange='$action_javascript'>\n";
if ($entete<>""){
	echo "<option value=\"\">--$entete--</option>";
}

if ($where==""){
	$resultat=db_query("select * from $nom_table order by $nom_champ");
}else{
	$resultat=db_query("select * from $nom_table where $where order by $nom_champ");
}
print_r($resultat);
	$nb=db_num_rows($resultat);

	$i=0;
	while($i<$nb) {
		$id=db_result($resultat,$i,"$id_champ");
		//recuperation du libelle
		$chaine=db_result($resultat,$i,"$nom_champ");
		//on coupe les chaines trop longues
		//$chaine=cut_string($chaine,$max);

		if ($i%2==0){
			$class="pair";
		}else{
			$class="impair";
		}
		
		if ($id==$selected){
			echo "<option class=\"".$class."\" value='". $id. "' selected>".$chaine."</option>\n";
		
			}
		else{
			echo "<option class=\"".$class."\" value='". $id. "'>".$chaine."</option>\n";
			}
	$i++;
	}

	echo "</select>\n";
}


?>
