<?php
session_start();
    # Page d'accueil de Echange entre geoBASEs
    # (C) MAP/SG/SM/SDSI/CERI/DIG 2006
    require('core/config.php');
    require('core/authentification_api.php');
    require('core/html_api.php');
    require('core/date_api.php');
    require('core/database_api.php');

   
//vérification de la session
$resultat=test_session("user"); 
if ($resultat === false ){
  $href="login.php?login=";
  echo "<meta http-equiv=\"refresh\" content=\"0; URL=$href\">\n";
}else{

  # Connexion à Page d'accueil
    html_begin( "Accueil", "" );
    html_bandeau();
    
    if (test_session("admin")<>1){
       warning_autorisation();
       html_end();
      }
    else{
      print_session();
       
    ?>
       
    <h1>Echange entre G&eacute;oBASEs</h1>

    <p>Ce module permet d'automatiser les échanges entres GéoBASE. A partir de cette page, vous pouvez autoriser les exportations des données de votre GéoBASE vers une autre GéoBASE et automatiser l'importation de données dans votre GéoBASE depuis une autre GéoBASE.</p>
    <p><b>Attention :</b> Seules les couches ayant une description locale dans le GéoRépertoire peuvent être échangées à travers GB_Echange. Les listes ne donneront donc accès qu'aux couches ayant une description locale. Pour ajouter une description locale, il suffit de se rendre dans GéoRépertoire, de vsualiser l'arborescence de sa GéoBASE et de sélectionner une couche dans l'arborescence, puis de cliquer sur "Ajouter une description locale".</p>
    <p>L'aide est disponible sur cette page : <a href="aide_import_export.php">Aide</a>.</p>

    <p>Cet outil vous permet de :</p>
    <ul>
    <li>Demander une couche dans une autre GéoBASE : Voir les <a href="import_gb.php">demandes en cours</a></li>
    <li>Autoriser une autre GéoBASE à venir chercher une couche : Voir les <a href="export_gb.php">autorisations</a></li>
    <p align="right"><a href="index.php?">[ Retour Accueil ]</a></p>

    <h2>Récapitulatif</h2>
    
    <table  >
    <tr></tr>
    <tr></tr>
    <tr class="txtcontenu">
       <td  colspan="7" >
            Liste des imports
            [&nbsp;<a href="add_import_page.php?action=add">Ajouter</a>&nbsp;]
       </td>
    </tr>
    </table>
    <table width="100%" frame="box" rules=rows cellpadding="5">
    <tr class="tabletexte"> 
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>Nom de la couche</td>
        <td>Nom du serveur GéoBASE</td>
        <td>Archiver ?</td>
        <td>Date dernier import</td>
        <td>Résultat dernier import</td>
    </tr>
    <?php
    $result=db_query('SELECT * FROM '.$g_schema_gb.'.gb_import order by nom_couche');
    $num_rows=db_num_rows($result);
    $i=0;
    if ($num_rows>0){
        while ($row=db_fetch_array($result)){
            $i++;
            if ($i%2 == 0){
                ?>  
                <tr class="evenRow">
                <?php
            }else{
                ?>
                <tr class="oddRow">
                <?php
            }
            if ($row['archiver']=='t'){
                $row['archiver']='Oui';
            }else{
                $row['archiver']='Non';
            }
            if ($row['date_import']=='1970-01-01 01:01:01'){
                    $row['date_import']='Aucun';
            }else{
                $row['date_import']=dateFrwithHour($row['date_import']);
            }
            ?>
            <td width=20>
            <center>
            <a href="add_import_page.php?action=edit&amp;nom_couche=<?php echo $row['nom_couche'] ?>">
                <img border="0" src="images/update.png" title="Editer la demande d'import" />
            </a>
            </center>
            </td>     
            <td width=20>
            <center>
            <a href="script_import.php?nom_couche=<?php echo $row['nom_couche'] ?>&amp;action=delete_import">
                <img border="0" src="images/delete.png" title="Supprimer la demande d'import" />
            </a>
            </center>
            </td>     
                <td><?php echo $row['nom_couche'] ?></td>
                <td><?php echo $row['nom_serveur'] ?></td>
                <td><?php echo $row['archiver'] ?></td>
                <td><?php echo $row['date_import'] ?></td>
                <td><?php echo $row['log_import'] ?></td>
            </tr>
            <?php
        }
    }
    ?>
    </table> 
    <table  >
    <tr></tr>
    <tr></tr>
    <tr class="txtcontenu">
       <td  colspan="7" >
            Liste des exports
            [&nbsp;<a href="add_export_page.php?action=add">Ajouter</a>&nbsp;]
       </td>
    </tr>
    </table>
    <table width="100%" frame="box" rules=rows cellpadding="5">
    <tr class="tabletexte"> 
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>Nom de la couche</td>
        <td>Nom du serveur GéoBASE</td>
    </tr>
    <?php
    $result=db_query('SELECT * FROM '.$g_schema_gb.'.gb_export order by nom_couche');
    $num_rows=db_num_rows($result);
    $i=0;
    if ($num_rows>0){
        while ($row=db_fetch_array($result)){
            $i++;
            if ($i%2 == 0){
                ?>  
                <tr class="evenRow">
                <?php
            }else{
                ?>
                <tr class="oddRow">
                <?php
            }
            ?>
            <td width=20>
            <center>
            <a href="add_export_page.php?action=edit&amp;id_export=<?php echo $row['id_export'] ?>">
                <img border="0" src="images/update.png" title="Editer l'autorisation d'export" />
            </a>
            </center>
            </td>     
            <td width=20>
            <center>
            <a href="script_export.php?id_export=<?php echo $row['id_export'] ?>&amp;action=delete_export">
                <img border="0" src="images/delete.png" title="Supprimer la demande d'import" />
            </a>
            </center>
            </td>     
                <td><?php echo $row['nom_couche'] ?></td>
                <td><?php echo $row['nom_serveur'] ?></td>
            </tr>
            <?php
        }
    }
    ?>
    </table>
    <p align="right"><a href="index.php?">[ Retour Accueil ]</a></p>
    <?php 
    html_end();
    }
}
 ?>
