<?php
session_start();
    # Page des autorisations d'import 
    # (C) MAP/SG/SM/SDSI/CERI/DIG 2006
    require('core/config.php');
    require('core/authentification_api.php');
    require('core/html_api.php');
    require('core/date_api.php');
    require('core/database_api.php');

   
    //vérification de la session
    $resultat=test_session("user"); 
    if ($resultat === false ){
        $href="login.php?login=";
        echo "<meta http-equiv=\"refresh\" content=\"0; URL=$href\">\n";
    }else{

    # Connexion à Page d'accueil
    html_begin( "Import", "" );
    html_bandeau();

    if (test_session("admin")<>1){
       warning_autorisation();
       html_end();
      }
    else{
      print_session();
       
    ?>
   
    <h1>Demandes d'importation de données</h1>

    <p>Cette page liste les couches importées depuis un autre serveur GéoBASE.</p>
    <table  >
    <tr></tr>
    <tr></tr>
    <tr class="txtcontenu">
       <td  colspan="7" >
            Liste des imports
            [&nbsp;<a href="add_import_page.php?action=add">Ajouter</a>&nbsp;]
       </td>
    </tr>
    </table>
    <table width="100%" frame="box" rules=rows cellpadding="5">
    <tr class="tabletexte"> 
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>Nom de la couche</td>
        <td>Nom du serveur GéoBASE</td>
        <td>Archiver ?</td>
        <td>Date dernier import</td>
        <td>Résultat dernier import</td>
    </tr>
    <?php
    $result=db_query('SELECT * FROM '.$g_schema_gb.'.gb_import order by nom_couche');
    $num_rows=db_num_rows($result);
    $i=0;
    if ($num_rows>0){
        while ($row=db_fetch_array($result)){
            $i++;
            if ($i%2 == 0){
                ?>  
                <tr class="evenRow">
                <?php
            }else{
                ?>
                <tr class="oddRow">
                <?php
            }
            if ($row['archiver']=='t'){
                $row['archiver']='Oui';
            }else{
                $row['archiver']='Non';
            }
            if ($row['date_import']=='1970-01-01 01:01:01'){
                    $row['date_import']='Aucun';
            }else{
                $row['date_import']=dateFrwithHour($row['date_import']);
            }
            ?>
            <td width=20>
            <center>
            <a href="add_import_page.php?action=edit&amp;nom_couche=<?php echo $row['nom_couche'] ?>">
                <img border="0" src="images/update.png" title="Editer la demande d'import" />
            </a>
            </center>
            </td>     
            <td width=20>
            <center>
            <a href="script_import.php?nom_couche=<?php echo $row['nom_couche'] ?>&amp;action=delete_import">
                <img border="0" src="images/delete.png" title="Supprimer la demande d'import" />
            </a>
            </center>
            </td>     
                <td><?php echo $row['nom_couche'] ?></td>
                <td><?php echo $row['nom_serveur'] ?></td>
                <td><?php echo $row['archiver'] ?></td>
                <td><?php echo $row['date_import'] ?></td>
                <td><?php echo $row['log_import'] ?></td>
            </tr>
            <?php
        }
    }
    ?>
    </table>
    <br />
    <p align="right"><a href="import_export.php">[ Retour ]</a></p>  
    <?php     
   // deconnexion 
    db_close();
    html_end();
    }
}
 ?>
