<?php
session_start();
# Page d'accueil de GeoMAP_Admin
# (C) MAP/SG/SM/SDSI/CERI/DIG 2006
require('core/config.php');
require('core/authentification_api.php');
require('core/html_api.php');
require('core/database_api.php');

//vérification de la session
$resultat=test_session("user"); 

if ($resultat === false ){
      $href="login.php?login=";
      echo "<meta http-equiv=\"refresh\" content=\"0; URL=$href\">\n";
}else{
  # Connexion à Page d'accueil
    html_begin( "Accueil", "" );
    html_bandeau();
    
    if (test_session("admin")<>1){
       warning_autorisation();
       ?>
       <p align="right"><a href="login.php?logout=">[ D&eacute;connexion ]</a></p>
       <?php
       html_end();
    }
    else{
      print_session();
       
    ?>
    <h1>Administration du projet GeoMAP</h1>
    <h2>Pr&eacute;sentation</h2>
    <p>L'administration du projet GeoMAP comprend plusieurs applications :</p>
        <ul>
         <li>La configuration de l'application d'&eacute;change entre G&eacute;oBASEs.</li>
        </ul>

    <hr />

    <h2>Actualités</h2>
	
    <h3>Mise à jour pour installation sur des serveurs eSBL</h3>

    <p>L'application est désormais disponible sur les serveurs eSBL.</p>    

    <h3>Mise à jour importante</h3>
    <p>Le site arbore un nouveau design et n'est plus coincé dans une fenêtre 800*600. Un nouveau menu plus pratique permet d'accéder aux différentes rubriques de l'application.</p>
    <p>Le module de reprojection en Lambert93 des couches de la GéoBASE est disponible. Il vous permet de transformer une ou plusieurs couches de votre GéoBASEs dans le système de référence RGF93.</p>
    
    <h3>Maintenance GéoBASE</h3>
    <p>Module permettant de gérer le renommage des couches suite à l'opération de mise en cohérence du nom des couches dans GéoREPERTOIRE.</p>

    <h3>Ajout de GB_Echange</h3>
    <p>Module permettant de réaliser les échanges entre GéoBASEs.</p>
    
    <hr />
    <h2>Historique des changements</h2>
    <ul>
	<li>12 mars 2012 (v3.2.0) : Mise à jour et configuration pour installation sur des serveurs eSBL.</li>
        <li>29 juin 09 (v3.1.0) : Ajout pages d'aide et correction de bugs.</li>
        <li>12 mai 09 (v3.0.0) : Ajout du module de reprojection et changement de design de l'application</li>
        <li>22 juillet 2008 (v2.1.0) : Création du Module de renommage.</li>
        <li>7 Octobre 2008 (v2.2.0) : Ajout de l'échange des couches versionnées.</li>
        <li>Décembre 2007 (v2.0.0) : Création du Module déchanges de données.</li>
    </ul>
    
    <?php 
    html_end();
    }
}
 ?>
